;   -  PIC16F84. 
;  , 18 ,  
;
;   
;     * PB3 * 	PA0,PA1 ;   
;   *         * 	PA2 .
; PB6        PB2	PA3 
;   *         *	PA4 
;     * PB4 *	
;   *         *	PB0  
; PB7        PB1	PB7   . > 
;   *         *	PB5   . < 
;     * PB5 *	PB1   . 
;
#include "p16f84.inc"

PWM_L	EQU	0X10	;. 
PWM_H	EQU	0X11	;. 
TUN_L	EQU	0X12	;. 
TUN_H	EQU	0X13	;. 
KEY0	EQU	0X14	;BITS 0= >, 1= <, 2= H, - 
KEY1	EQU	0X15	;  
KEY2	EQU	0X16	;-  
TMP	EQU	0X17	;. 
CAN	EQU	0X18	; 
COUN_L	EQU	0X19	;  .
COUN_H	EQU	0X1A	;  .
TMPHF	EQU	0X1C	;   "H"
TMPCAN	EQU	0X1D	;   "CANPL"  "CANMI"	
TMPAG	EQU	0X1E	;   
TMPTUN	EQU	0X1F	;   "TUNPL","TUNMI"
FLAGS	EQU	0X20	; : 	0 -   EEPROM
			;		1 -  TMPHF 
			;		2 -  TMPCAN
			;		3 -  TMPAG
			;		4 -  TMPTUN 
									
;*********************INIT

	BCF	STATUS,IRP	;
	BCF	STATUS,RP1	;
	MOVLW	0X01	;
	BSF	STATUS,RP0	;  1
	MOVWF	TRISB	;
	CLRF	TRISA	;
	BCF	INTCON,GIE	; 
	MOVLW	0X0A	;PULLUP=ON, PRESCALER WDT=ON, nWDT=4 (4*18ms)
	MOVWF	OPTION_REG	; 
	MOVLW	0X01	;	
	BCF	STATUS,RP0	;  0
	BTFSC	STATUS,4	;   WDT (TO=0), CAN  
	MOVWF	CAN	;
	CLRF	TUN_H	;
	CLRF	COUN_H	;
	CLRF	COUN_L	;
	CLRF	KEY0	;
	CLRF	KEY1	;
	CLRF	KEY2	;
	CLRF	FLAGS	;
	CLRF	PORTA	;
	CLRF	PORTB	;
	BSF	PORTB,0	;
	MOVLW	0X20	;.  
	MOVWF	TMPAG	;
	CALL	EEPROM	;   TUN_L  TUN_H 


		
START:
;(SETDP)************** 
	CLRWDT		;
	MOVF	CAN,0	;
	SUBLW	0X12	; (0X10  PIC16F83)
	BTFSC	STATUS,Z	;     012 (0X10),
	GOTO	SETDP3	;  	
	MOVF	CAN,1	;	
	BTFSS	STATUS,Z	;     "0",
	GOTO	SETDP1	; 
	BSF	PORTA,3	;  
	GOTO	SETDP2	;
SETDP1:	BCF	PORTA,3	;   "0" -  	
SETDP2:	MOVF	TUN_H,0	;
	ANDLW	0X30	;   
	MOVWF	TMP	;   0-1	
	MOVLW	0XFC	;
	ANDWF	PORTA,1	;
	SWAPF	TMP,0	;
	IORWF	PORTA,1	;
	GOTO	SETDP4	;
SETDP3:	MOVLW	0X08	;
	MOVWF	PORTA	;  
SETDP4:

;(AG)***********************
	MOVF	TMPAG,0	;
	SUBWF	COUN_H,0	;  TMPAG  COUN_H,
	BTFSS	STATUS,C	;    		
	GOTO	AG1	;
	BTFSC	FLAGS,3	;   , 
	GOTO	AG1	; 
	MOVF	COUN_H,0	;  TMPAG  COUN_H
	MOVWF	TMPAG	;  
	BCF	PORTA,2	;   
	GOTO	AG2	;
AG1:	BSF	PORTA,2	; 
	NOP		;  .
	NOP		;
	NOP		;
	NOP		;
AG2:			;		
;************************************	
	MOVLW	0XF0	;
	ANDWF	COUN_L,1	;    
	MOVLW	0X10	;   
	ADDWF	COUN_L,1	;   010
	BTFSS	STATUS,Z	; 
	GOTO	KEYSCA1	;
	INCFSZ	COUN_H	;     FF  0
	GOTO	KEYSCA1	;
	INCF	TMPHF	;    (HNDF)
	BCF	FLAGS,1	;    	
	INCF	TMPAG	;    (AG)
	BCF	FLAGS,3	;    	
	INCF	TMPTUN	;    (TUNPL/TUNMI)
	BCF	FLAGS,4	;    		
	INCF	TMPCAN	;    (CANPL/CANMI)
	BCF	FLAGS,2	;    		

;(KEYSCA)*******************   	
			
KEYSCA1:	MOVF	KEY1,0	;	
	MOVWF	KEY2	;
	MOVF	KEY0,0	;	
	MOVWF	KEY1	;
	MOVLW	0XFF	;
	MOVWF	PORTB	;
	CLRF	TMP	;
	BCF	PORTB,7	; . ">"
	BTFSS	PORTB,0	;
	BSF	TMP,0	;  
	BSF	PORTB,7	;
	BCF	PORTB,5	; . "<" 
	BTFSS	PORTB,0	;
	BSF	TMP,1	;  
	BSF	PORTB,5	;
	BCF	PORTB,1	;  "H"
	BTFSS	PORTB,0	;
	BSF	TMP,2	; 
	BSF	PORTB,1	;
	CLRF	KEY0	;
	BCF	PORTB,7	;  . ">"
	BTFSS	PORTB,0	;
	BSF	KEY0,0	; 
	BSF	PORTB,7	;
	BCF	PORTB,5	;  . "<"
	BTFSS	PORTB,0	;
	BSF	KEY0,1	; 
	BSF	PORTB,5	;
	BCF	PORTB,1	;  ."H"
	BTFSS	PORTB,0	;
	BSF	KEY0,2	;
	BSF	PORTB,1	;		
	MOVF	KEY0,0	;    
	ANDLW	0X07	;   
	SUBWF	TMP,0	; 
	BTFSC	STATUS,Z	;    ,
	GOTO	KEYSCA2	;  
	MOVF	KEY1,0	;  - 
	MOVWF	KEY0	;  KEY0  
KEYSCA2:	CLRF	PORTB	;


;(WEEPR)******************  EEPROM    
WEEPR0:	BTFSC	KEY0,2	;    "H"  
	GOTO	WEEPREX	; 
	BTFSC	KEY1,2	;
	GOTO	WEEPREX	;
	BTFSS	KEY2,2	;        "H",
	GOTO	WEEPREX	;  
	BTFSS	FLAGS,0	;       
	GOTO	WEEPREX	;  
	MOVF	CAN,0	;
	MOVWF	TMP	;
	BCF	STATUS,C	;
	RLF	TMP,0	;
	MOVWF	EEADR	;
	MOVF	TUN_L,0	;
	MOVWF	EEDATA	;
	CALL	WEEPROM	;
	INCF	EEADR	; 
	MOVF	TUN_H,0	;
	MOVWF	EEDATA	;
	CALL	WEEPROM	;     EEPROM
	BCF	FLAGS,0	;    
WEEPREX:
;(HNDF)******************   "H"  
	BTFSS	KEY1,2	;    
	GOTO	HNDF8	;   
	BTFSC	KEY0,2	; ,  
	GOTO	HNDF6	;
HNDF8:	MOVLW	0X0A	;
	MOVWF	TMP	;   
HNDF7:	DECFSZ	TMP	;
	GOTO	HNDF7	;	
	GOTO	HNDF2	;   
HNDF6:	MOVF	COUN_H,0	;
	ADDLW	0X08	;   
	BTFSC	STATUS,C	;  ,
	BSF	FLAGS,3	;  	
	MOVWF	TMPAG	;
	BTFSC	KEY2,2	;    ,	
	GOTO	HNDF1	;  	
	MOVF	COUN_H,0	;    TMPHF 
	ADDLW	0X20	;  COUN_H,  020
	BTFSC	STATUS,C	;  ,
	BSF	FLAGS,1	;   
	MOVWF	TMPHF	; 
HNDF1:	MOVF	TMPHF,0	;  TMPHF  COUN_H 
	SUBWF	COUN_H,0	; 
	BTFSC	STATUS,C	; 
	GOTO	HNDF4	;
HNDF9:	MOVLW	0X14	;   
	MOVWF	TMP	; 
HNDF5:	DECFSZ	TMP,1	;
	GOTO	HNDF5	;
	GOTO	PWM0	;
HNDF4:	BTFSC	FLAGS,1	;   ,
	GOTO	HNDF9	;
	MOVF	COUN_H,0	; 
	MOVWF	TMPHF	;  TMPHF  COUN_H
	GOTO	TUNDYS1	;
HNDF2:	;MOVLW	0X01	;  
	;MOVWF	TMP	;
HNDF3:	;DECFSZ	TMP,1	;
	;GOTO	HNDF3	;
	
;(CANDYS)******************  		
	MOVF	CAN,0	;
	CALL	TABLE1	;
	MOVWF	PORTB	;
	GOTO	EXHNDF	; 
;***************  7- .
TABLE1:	ADDWF	PCL	;
	RETLW	0XEE	;0	0
	RETLW	0X06	;1	1
	RETLW	0XBC	;2	2
	RETLW	0X3E	;3	3
	RETLW	0X56	;4	4
	RETLW	0X7A	;5	5
	RETLW	0XFA	;6	6
	RETLW	0X0E	;7	7
	RETLW	0XFE	;8	8
	RETLW	0X7E	;9	9
	RETLW	0XDE	;A	A
	RETLW	0XF2	;B	B
	RETLW	0XE8	;C	C
	RETLW	0XB6	;D	D
	RETLW	0XF8	;E	E
	RETLW	0XD8	;F	F
	RETLW	0XEA	;G	10 (0XE6  PIC16F83)
	RETLW	0XD6	;H	11
	RETLW	0XE6	;V	12
	RETLW	0X20	;_	13	
	RETLW	0X02	;I	14
	RETLW	0X82	;II	15
	RETLW	0XA2	;u	16
	RETLW	0X40	;(1)	17	
	RETLW	0X48	;(2)	18
	RETLW	0X08	;(3)	19	
	RETLW	0X0C	;(4)	1A
	RETLW	0X04	;(5)	1B
	RETLW	0X14	;(6)	1C					
	RETLW	0X10	;(7)	1D
	RETLW	0X10	;(8)	1E
	
	
;(TUNDYS)******************  	
TUNDYS1	BTFSS	COUN_H,0	;      COUN_H	
	GOTO	TUNDYS2	;
	MOVF	TUN_H,0	;
	MOVWF	TMP	;
	SWAPF	TMP,0	;    
	ANDLW	0X03	;  
	ADDLW	0X13	; 
	CALL	TABLE1	;
	MOVWF	PORTB	;	
	GOTO	TUNDYS4	;
TUNDYS2:	MOVLW	0X04	;
	MOVWF	TMP	;  
TUNDYS3:	DECFSZ	TMP	;
	GOTO	TUNDYS3	;
TUNDYS4:	MOVF	TUN_H,0	;
	MOVWF	TMP	;
	RRF	TMP,0	;    
	ANDLW	0X07	;  
	ADDLW	0X17	;
	CALL	TABLE1	;
	ADDWF	PORTB,0	;
	MOVWF	PORTB	;

;(TUNPL)****************   	
TUNPL1:	BTFSS	KEY0,0	;    ">"
	GOTO	TUNMI1	;  , - 
	BTFSS	KEY1,0	;
	GOTO	TUNMI1	;
	NOP		;    
	NOP		;
	NOP		;
	NOP		;
	NOP		;
	MOVF	COUN_H,0	;  
	BTFSC	KEY2,0	;     ,	
	GOTO	TUNPL2	;  
	ADDLW	0X20	;      020 
	BTFSC	STATUS,C	;  ,
	BSF	FLAGS,4	;  
	MOVWF	TMPTUN	;
TUNPL2:	MOVF	TMPTUN,0	;  TMPTUN  TUN_H 
	SUBWF	COUN_H,0	;
	BTFSS	STATUS,C	;
	GOTO	TUNPL4	;
	BTFSC	FLAGS,4	;   ,
	GOTO	TUNPL4	;
	MOVF	COUN_H,0	;   ,
	MOVWF	TMPTUN	;  TMPTUN  TUN_H
	GOTO	TUNPL3	;
TUNPL4:	MOVF	COUN_L,0	;     
	ANDLW	0X70	;   TMPTUN,
	BTFSS	STATUS,Z	;     
	GOTO	TUNMI8	;     
TUNPL3:	INCFSZ	TUN_L	; 	
	GOTO	TUNMI8	;
	INCF	TUN_H	;     
	MOVLW	0X10	; , 
	BTFSC	TUN_H,6	;   
	MOVWF	TUN_H	;
	GOTO	TUNMI8	;

;(TUNMI)***************   	
TUNMI1:	BTFSS	KEY0,1	;    "<"
	GOTO	TUNMI5	;  , - 
	BTFSS	KEY1,1	;
	GOTO	TUNMI5	;
	MOVF	COUN_H,0	;  
	BTFSC	KEY2,1	;     ,	
	GOTO	TUNMI2	;  
	ADDLW	0X20	;      020
	BTFSC	STATUS,C	;  ,
	BSF	FLAGS,4	;  	 
	MOVWF	TMPTUN	;
TUNMI2:	MOVF	TMPTUN,0	;
	SUBWF	COUN_H,0	;  TMPTUN  TUN_H
	BTFSS	STATUS,C	;
	GOTO	TUNMI4	;
	BTFSC	FLAGS,4	;   ,
	GOTO	TUNMI4	;	
	MOVF	COUN_H,0	;
	MOVWF	TMPTUN	;
	GOTO	TUNMI3	;     
TUNMI4:	MOVF	COUN_L,0	;   TMPTUN,
	ANDLW	0X70	;     
	BTFSS	STATUS,Z	;     
	GOTO	TUNMI8	;
TUNMI3:	MOVLW	0X01	;
	SUBWF	TUN_L,1	;   	TUN_L
	BTFSC	STATUS,C	;		
	GOTO	TUNMI8	;
	DECF	TUN_H,1	;  TUN_H
	MOVF	TUN_H,0	;
	ANDLW	0X30	;   ( 4, 5 TUN_H)
	BTFSS	STATUS,Z	;
	GOTO	TUNMI8	;		
	MOVLW	0X3F	;      ,
	MOVWF	TUN_H	;     
TUNMI8: 	BSF	FLAGS,0	;      EEPROM
	GOTO	TUNMI6	;
TUNMI5:	MOVLW	0X06	;  
	MOVWF	TMP	;
TUNMI7:	DECFSZ	TMP	;
	GOTO	TUNMI7	;
TUNMI6:	GOTO	PWM0	;

EXHNDF:

;(CANPL)******************    
CANPL1:	BTFSS	KEY0,0	;     
	GOTO	CANPL4	;   
 	BTFSS	KEY1,0	;
 	GOTO	CANPL4	;
	MOVF	COUN_H,0	;
	ADDLW	0X08	;   
	BTFSC	STATUS,C	;  ,
	BSF	FLAGS,3	;  
	MOVWF	TMPAG	;	
	BTFSC	KEY2,0	;      . ">"
	GOTO	CANPL5	;    CANPL5
	GOTO	CANPL6	;
CANPL5:	MOVF	TMPCAN,0	;     , 
	SUBWF	COUN_H,0	;   
	BTFSS	STATUS,C	;
	GOTO	CANPL4	;
	BTFSC	FLAGS,2	;
	GOTO	CANPL4	;
CANPL6:	MOVF	COUN_H,0	;   
	ADDLW	0X04	;   TMPCAN 
	BTFSC	STATUS,C	;  0X04H   COUN_H
	BSF	FLAGS,2	;  ,  	 
	MOVWF	TMPCAN	;	      
	INCF	CAN,1	;    
	MOVLW	0X13	;   W 013, (0X11  PIC16F83)
	SUBWF	CAN,0	; 
	BTFSC	STATUS,C	;   , 
	CLRF	CAN	;   "0"
	CALL	EEPROM	;   EEPROM  
	GOTO	CANEX	;
CANPL4:	
			
;(CANMI)******************   
CANMI1:	BTFSS	KEY0,1	;     
	GOTO	CANMIEX	;    
	BTFSS	KEY1,1	;
	GOTO	CANMIEX	;	
	MOVF	COUN_H,0	;
	ADDLW	0X08	;   
	BTFSC	STATUS,C	;  ,
	BSF	FLAGS,3	;  	
	MOVWF	TMPAG	;
	BTFSC	KEY2,1	;      . "<"
	GOTO	CANMI2	;    CANMI2
	GOTO	CANMI3	;		
CANMI2	MOVF	TMPCAN,0	;     , 
	SUBWF	COUN_H,0	;   
	BTFSS	STATUS,C	;
	GOTO	CANMIEX	;
	BTFSC	FLAGS,2	;
	GOTO	CANMIEX	;		
CANMI3	MOVF	COUN_H,0	;   
	ADDLW	0X04	;   TMPCAN 
	BTFSC	STATUS,C	;  0X04H   COUN_H
	BSF	FLAGS,2	;  ,   
	MOVWF	TMPCAN	;	    
	MOVF	CAN,1	; 
	BTFSS	STATUS,Z	;    "0"   CAN
	GOTO	CANMI6	;  ,  
	MOVLW	0X13	;  ,   013 (0X11  PIC16F83)
	MOVWF	CAN	;
CANMI6:	DECF	CAN,1	;    
	CALL	EEPROM	;   EEPROM  
	GOTO	CANEX	;
CANMIEX:	MOVLW	0X08	;  
	MOVWF	TMP	;
CANMIE1:	DECFSZ	TMP,1	;
	GOTO	CANMIE1	;
CANEX:

;(PWM)***************                 
PWM0:	MOVF	TUN_L,0	;	
	MOVWF	PWM_L	; 
	INCF	PWM_L,1	;   
	MOVF	TUN_H,0	;   
	ANDLW	0X0F	;   .
	MOVWF	PWM_H	;   
	INCF	PWM_H,1	;
	BCF	PORTA,4	;  0   
PWM1:	DECFSZ	PWM_L,1	;   DEC 
	GOTO	PWM1	; 
	DECFSZ	PWM_H,1	; 
	GOTO	PWM1	; 

;-------------------  
	COMF	TUN_H,0	;    
	ANDLW	0X0F	;   .
	MOVWF	PWM_H	;     
	COMF	TUN_L,0	;   
	MOVWF	PWM_L	;   
	BSF	PORTA,4	;  1   
	INCF	PWM_H,1	;
	INCF	PWM_L,1	;
PWM2:	DECFSZ	PWM_L,1	; DEC 
	GOTO	PWM2	; 
	DECFSZ	PWM_H,1	; 
	GOTO	PWM2	; 
;*********************************************************
	GOTO	START	;  
;*********************************************************	

;

;(EEPROM)*****************    EEPROM	
EEPROM:	MOVF	CAN,0	;
	MOVWF	TMP	;
	BCF	STATUS,C	;
	RLF	TMP,0	;
	CALL	REEPROM	;
	MOVWF	TUN_L	;
	MOVF	CAN,0	;
	MOVWF	TMP	;
	RLF	TMP,1	;
	INCF	TMP,0	;
	CALL	REEPROM	;
	ANDLW	0X3F	;
	MOVWF	TUN_H	;	
	RETURN		;
		
;(REEPROM)****************** EEPROM
REEPROM:	
	BCF	STATUS,RP0	;  0
	MOVWF	EEADR 	;  
	BSF	STATUS,RP0 ;  1	
	BSF 	EECON1,RD 	;   
	BCF 	STATUS,RP0 ;  0
	MOVF 	EEDATA,0 	; W = EEDATA
	RETURN
	
;(WEEPROM)**********************  EEPROM	
WEEPROM:	BSF	STATUS,RP0	;  1
	BCF 	INTCON,GIE	;  .
	BSF	EECON1,WREN;  
	MOVLW	0X55	;
	MOVWF	EECON2	;  55h
	MOVLW	0XAA	;
	MOVWF	EECON2	;  AAh
	BSF	EECON1,WR	;   WR
;  
WEEPROM1:	BTFSC	EECON1,WR	;   
	GOTO	WEEPROM1	;    - 	
	BCF	EECON1,WREN;  WREN
	BCF	STATUS,RP0	; 0
	RETURN

	END
EOF	


	
